﻿namespace UltraWeekViewCustomPainting
{
    using System.Collections.Generic;
    using System.Drawing;
    using System.Linq;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinSchedule.WeekView;

    internal class DF : IUIElementDrawFilter
    {
        private List<TransferInfo> transfers;
        private UserControl1 us = new UserControl1();

        public DF(List<TransferInfo> transfers)
        {
            this.transfers = transfers;
        }

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            var dayElement = drawParams.Element as DayUIElement;
            if(dayElement != null)
            {
                var transfer = this.transfers.FirstOrDefault(t => t.Date == dayElement.Date);
                if(transfer != null)
                {
                    this.us.AddTransfer(transfer);
                    var result = new Bitmap(this.us.Width, this.us.Height);
                    this.us.DrawToBitmap(result, this.us.Bounds);
                    result.Save("test.png");

                    var rect = dayElement.RectInsideBorders;
                    var dayNumberElement = dayElement.GetDescendant(typeof(DayNumberUIElement));
                    if(dayNumberElement != null)
                    {
                        rect.Inflate(-5, -dayNumberElement.Rect.Height - 5);
                    }

                    drawParams.Graphics.DrawImage(result, rect.Location);
                }
            }

            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if(drawParams.Element is DayUIElement)
            {
                return DrawPhase.AfterDrawElement;
            }

            return DrawPhase.None;
        }
    }
}
