﻿namespace UltraWeekViewCustomPainting
{
    using System.Collections.Generic;
    using System.Windows.Forms;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinGrid;

    public partial class UserControl1 : UserControl
    {
        private List<TransferInfo> transfers;

        public UserControl1()
        {
            this.InitializeComponent();

            this.Load += UserControl1_Load;
            this.ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;

            this.transfers = new List<TransferInfo>();
        }

        private void UserControl1_Load(object sender, System.EventArgs e)
        {
            this.ultraGrid1.DataSource = this.Transfers;
            this.ultraGrid1.DisplayLayout.PerformAutoResizeColumns(false, PerformAutoSizeType.AllRowsInBand);
        }

        private void UltraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["Date"].Hidden = true;
            e.Layout.Override.RowSelectors = DefaultableBoolean.False;
            e.Layout.AutoFitStyle = AutoFitStyle.ResizeAllColumns;
        }

        public List<TransferInfo> Transfers
        {
            get { return this.transfers; }
        }

        public void AddTransfer(TransferInfo transfer)
        {
            this.transfers.Add(transfer);
        }
    }
}
